/********************************************************
 --------------------------------------------------------
 - Object 목록								            -
 --------------------------------------------------------
 * let pageObj = {}			: 화면공통 Object			*
 * let viewObj = {}			: 상세화면 Object			*
 *******************************************************/
 require(['config'], function() {
	require([
		'kakao.map.util'
	], function($) {
		pageObj.init();
	});
});

google.charts.load('current', {'packages':['corechart']});
google.charts.setOnLoadCallback(drawChart1);
google.charts.setOnLoadCallback(drawChart2);
 
function drawChart1() {
	var data = google.visualization.arrayToDataTable([
     	['Year', 'Sales', 'Expenses'],
     	['9월',  1000,      400],
     	['10월',  1170,      460],
     	['11월',  660,       1120],
     	['12월',  1030,      540]
   	]);

   	var options = {
    	title: '1년전 구매기준',
     	legend: { position: 'bottom' }
   	};

   	var chart = new google.visualization.LineChart(document.getElementById('ITP_PCH_STDD'));

   	chart.draw(data, options);
}

function drawChart2() {
	var data = google.visualization.arrayToDataTable([
	     ['Year', 'Sales', 'Expenses'],
	     ['9월',  1000,      400],
	     ['10월',  1170,      460],
	     ['11월',  660,       1120],
	     ['12월',  1030,      540]
	]);

	var options = {
		title: '최근 구매기준',
	    legend: { position: 'bottom' }
	};

	var chart = new google.visualization.LineChart(document.getElementById('ITP_PCH_NEW_STDD'));
	chart.draw(data, options);
}

require(['config'], function() {
	require([
		'jquery.bootstrap.fileUpload' //파일 업로드가 있는 페이지에서 로딩
	], function($) {
		pageObj.init();
	});
});

/********************************************************
 --------------------------------------------------------
 - Object 목록								            -
 --------------------------------------------------------
 * const gridColModel = {}	: 화면 Grid Object			*
 * let pageObj = {}			: 화면공통 Object			*
 * let listObj = {}			: 목록화면 Object			*
 * let viewObj = {}			: 상세화면 Object			*
 * let modifyObj = {}		: 수정화면 Object			*
 * let createObj = {}		: 신규화면 Object			*
 *******************************************************/

/*화면 변수*/

let ITP_FORM_STINFO07010_DETAIL_IS_DUPLICATE = false;
let ITP_FORM_STINFO07010_DETAIL_IS_WRITING = false;

/*API URL*/
let API_DETAIL_GRID_LIST 	= '/api/itemunit/detail-grid-list';	    // 목록
let API_DETAIL_INFO 		= '/api/itemunit/info-itemunit';		// 상세
let API_DETAIL_SAVE 		= '/api/itemunit/save-itemunit';		// 저장
let API_ITEM_CLASS_LEVEL	= '/api/item/class-level-list';			//품목분류 level 검색

/*화면공통 Object*/
let pageObj = {
	init: function () {
		this.ui.init();
		this.event.init();
	},
	ui: {
		init: function () {
			this.view();
			this.grid();
			this.ready();
		},
		view: function() {
			// 버튼 권한설정
			fn_proc_btn_auth('STINFO07010');

			// 공통코드 표시
			
		},
		grid: function() {
		},
		ready: function() {
		}
	},
	event: {
		init: function () {
			this.button();
		},
		button: function () {
			// 버튼 클릭 이벤트
			$('button').each(function() {
				var id = $(this).attr('id');
				$(this).on('click', function() {
					switch (id) {
						case 'ITP_BTN_STINFO07010_SRH'				: listObj.button.search();		break;	// 조회 버튼 클릭
					}
				});
			});

		}
	},
	switchScreen: function(mode) {
		
	}
};

/*상세화면 Object*/
let viewObj = {
	init: function (param) {
		this.load(param);
	},
	load: function(param) {
		fn_ajax_call(API_DETAIL_INFO, param, this.callback, 'GET');
	},
	callback: function (result) {
		// console.log(result);
		// pageObj.switchScreen('VIEW');
		$('#ITP_FORM_STINFO07010_VIEW #ITP_FORM_STINFO07010_VIEW_ITEM_ID').val(result.itemId);
		$('#ITP_FORM_STINFO07010_VIEW .fnBrandNm').text(result.brandNm);

		
	}
};
